dist: xenial
language: php

cache:
    directories:
        - $HOME/.composer/cache

php:
    - 7.1
    - 7.2
    - 7.3
    - 7.4

services:
    - mongodb
    - memcached
    - redis-server
    - docker

before_install:
    - pecl channel-update pecl.php.net
    - pecl config-set preferred_state beta
    - echo yes | pecl upgrade apcu
    - mv ~/.phpenv/versions/$(phpenv version-name)/etc/conf.d/xdebug.ini{,.disabled} || echo "xdebug not available"
    - phpenv config-add ./tests/travis/php.ini

install:
    - rm composer.lock
    - travis_retry composer update --no-interaction --prefer-dist

script: ./vendor/bin/phpunit --exclude-group performance

jobs:
  allow_failures:
    - php: nightly

  include:
    -   stage: Test
        php: nightly
        before_install:
            - composer config platform.php 7.4.99

    - stage: Coding standard
      install:
          - travis_retry composer install --no-interaction --prefer-dist --ignore-platform-reqs
      script:
        - ./vendor/bin/phpcs

    - stage: Coverage
      before_script:
        - mv ~/.phpenv/versions/$(phpenv version-name)/etc/conf.d/xdebug.ini{.disabled,}
        - if [[ ! $(php -m | grep -si xdebug) ]]; then echo "xdebug required for coverage"; exit 1; fi
      script:
        - ./vendor/bin/phpunit --exclude-group performance --coverage-clover clover.xml
      after_success:
        - bash <(curl -s https://codecov.io/bash)
